// "Lithuanian charset converter" is free open-source cross-platform software made by Cognaxon.
// Download offline version and source code (HTML5 + JavaScript) from the address:
// http://cognaxon.com/downloads/LithuanianCharSetConverter/online/LithuanianCharSetConverterHTML.zip


window.onload = function() 
{
	
	
var LithuanianCharSetTable = new Uint8Array([
0x41,0x43,0x45,0x45,0x49,0x53,0x55,0x55,0x5a,0x61,0x63,0x65,0x65,0x69,0x73,0x75,0x75,0x7a, // ASCII
0xb5,0xb6,0xb7,0xb8,0xbd,0xbe,0xc6,0xc7,0xcf,0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,0xd8, // 772/774/775
0x8f,0x80,0x8b,0x90,0xad,0x9f,0xa7,0xa6,0x92,0x85,0x87,0x8a,0x82,0x8d,0x9e,0x97,0x96,0x91, // 770 (IBM Baltic)
0xdc,0xde,0xf0,0xf2,0xf4,0xf6,0xf8,0xfa,0xfc,0xdd,0xdf,0xf1,0xf3,0xf5,0xf7,0xf9,0xfb,0xfd, // 771/773/KBL
0xc0,0xc8,0xc6,0xcb,0xc1,0xd0,0xd8,0xdb,0xde,0xe0,0xe8,0xe6,0xeb,0xe1,0xf0,0xf8,0xfb,0xfe, // Windows-1257/Baltic-RIM/Latin-7/ISO-8859-13
0xa1,0xc8,0xca,0xcc,0xc7,0xa9,0xd9,0xde,0xae,0xb1,0xe8,0xea,0xec,0xe7,0xb9,0xf9,0xfe,0xbe, // Latin-4/ISO-8859-4/Latin-6/ISO-8859-10
0xc4,0xc4,0xc4,0xc4,0xc4,0xc5,0xc5,0xc5,0xc5,0xc4,0xc4,0xc4,0xc4,0xc4,0xc5,0xc5,0xc5,0xc5, // UTF-8 first byte
0x84,0x8c,0x98,0x96,0xae,0xa0,0xb2,0xaa,0xbd,0x85,0x8d,0x99,0x97,0xaf,0xa1,0xb3,0xab,0xbe  // UTF-8 second byte
]);

	
	
	
var fileInput = document.getElementById('fileInput');
var fileDisplayArea = document.getElementById('fileDisplayArea');


fileInput.addEventListener('change', function(e) {

var i_file;
var file;
var textType;
var inputFileFullName;
var inputFileName;
var inputFileExtension;
var outputFileName;


fileDisplayArea.innerText = "";

for (i_file = 0; i_file < fileInput.files.length; i_file++)
{

file = fileInput.files[i_file];
textType = /text.*/;



if (file.type.match(textType)) 
{
var reader = new FileReader();

reader.onload = (function(file)		
{
return function(e0) {	
	

var arrayBuffer =  e0.target.result;	
var dataView = new DataView(arrayBuffer, 0, arrayBuffer.byteLength);



var e1 = document.getElementById('input_file_charset');
var input_file_charset_selected_index = e1.selectedIndex - 1;
//var input_file_format_selected_value = e1.options[e1.selectedIndex].value;	
//var input_file_format_selected_text = e1.options[e1.selectedIndex].text;

var e2 = document.getElementById('output_file_charset');
var output_file_charset_selected_index = e2.selectedIndex;	

var e3 = document.getElementById('output_file_format');
var output_file_format_selected_index = e3.selectedIndex;	

//fileDisplayArea.innerText += "input_file_charset_selected_index = " + input_file_charset_selected_index + "\noutput_file_format_selected_index = " + output_file_charset_selected_index + "\n";


var number_of_replaced_characters;
number_of_replaced_characters = 0;

var i, i2;
i = 0;
i2 = 0;

var char_was_replaced; 


var output_array;
var current_byte, current_byte2;
var table_value, table_value2;  
var icharset;


var number_of_nulls = 0;
var max_number_of_lithuanian_chars = 0;


var CharSetStatisticsTable = new Uint32Array(8);

for (i = 0; i < 8; i++) 
{CharSetStatisticsTable[i] = 0;}



//===================================
if(input_file_charset_selected_index == -1) // Autodetect Lithuanian charset
{


if((dataView.getUint8(0) == 0xef)&(dataView.getUint8(1) == 0xbb)&(dataView.getUint8(2) == 0xbf)) // UTF-8 BOM (byte order mark)
{
  input_file_charset_selected_index = 6; // UTF-8 BOM (byte order mark)
  
  
// Count number of Lithuanian UTF-8 characters
for (i = 3; i < arrayBuffer.byteLength-1; i++) 
{ 

  current_byte = dataView.getUint8(i);
  current_byte2 = dataView.getUint8(i+1);
			
//-----------     
   if(current_byte == 0)
   {
     number_of_nulls++;
   }
   else if(current_byte > 127)
   {   
	 for(icharset = 0; icharset < 18; icharset++)
	 {		
		table_value = LithuanianCharSetTable[icharset+108]; // UTF-8 first byte
		table_value2 = LithuanianCharSetTable[icharset+126]; // UTF-8 second byte
		if ((table_value == current_byte) & (table_value2 == current_byte2))
		{
         CharSetStatisticsTable[6]++; // UTF-8 BOM (byte order mark)
		 break;
		}//if (table_value = current_byte)
      }//for(icharset = 0; icharset < 18; icharset++)
   }//else if(current_byte > 127)
//-----------		
	
}//for (i = 0; i < arrayBuffer.byteLength; i++)   
  
	max_number_of_lithuanian_chars = CharSetStatisticsTable[6];  


} // if((dataView.getUint8(0) == 0xef)&(dataView.getUint8(1) == 0xbb)&(dataView.getUint8(2) == 0xbf)) // UTF-8 BOM (byte order mark)
else
{	

number_of_nulls = 0;

// Count number of Lithuanian non-UTF-8 characters
for (i = 0; i < arrayBuffer.byteLength; i++) 
{ 

  current_byte = dataView.getUint8(i);
			
//-----------     
   if(current_byte == 0)
   {
     number_of_nulls++;
   }
   else if(current_byte > 127)
   {   
	for(i2 = 1; i2 < 6; i2++)
	{
	 for(icharset = 0; icharset < 18; icharset++)
	 {		
		table_value = LithuanianCharSetTable[icharset+(18*i2)];
		if (table_value == current_byte)
		{
         CharSetStatisticsTable[i2]++;
		 break;
		}//if (table_value = current_byte)
      }//for(icharset = 0; icharset < 18; icharset++)
	}//for(i2 = 1; i2 < 6; i2++)
   }//else if(current_byte > 127)
//-----------		
	
}//for (i = 0; i < arrayBuffer.byteLength; i++) 

	
// Count number of Lithuanian UTF-8 characters
for (i = 0; i < arrayBuffer.byteLength-1; i++) 
{ 

  current_byte = dataView.getUint8(i);
  current_byte2 = dataView.getUint8(i+1);
			
//-----------     
   if(current_byte == 0)
   {
     //number_of_nulls++;
   }
   else if(current_byte > 127)
   {   
	 for(icharset = 0; icharset < 18; icharset++)
	 {		
		table_value = LithuanianCharSetTable[icharset+108]; // UTF-8 first byte
		table_value2 = LithuanianCharSetTable[icharset+126]; // UTF-8 second byte
		if ((table_value == current_byte) & (table_value2 == current_byte2))
		{
         CharSetStatisticsTable[7]++; // UTF-8
		 break;
		}//if (table_value = current_byte)
      }//for(icharset = 0; icharset < 18; icharset++)
   }//else if(current_byte > 127)
//-----------		
	
}//for (i = 0; i < arrayBuffer.byteLength; i++) 
	
	
	
max_number_of_lithuanian_chars = 0;
	
for(i2 = 1; i2 < 8; i2++)
{
  if(CharSetStatisticsTable[i2] > max_number_of_lithuanian_chars)
  {
	max_number_of_lithuanian_chars = CharSetStatisticsTable[i2];  
    input_file_charset_selected_index = i2;
  }
}//for(i2 = 1; i2 < 6; i2++)	

	
	
}//if((dataView.getUint8(0) == 0xef)&(dataView.getUint8(1) == 0xbb)&(dataView.getUint8(2) == 0xbf)) // UTF-8 BOM (byte order mark)	
	

// e1.selectedIndex = input_file_charset_selected_index + 1; //set autodetected value to DropDownList
// fileDisplayArea.innerText += "Autodetected Lithuanian charset of input file: " + e1.options[e1.selectedIndex].text + "\n";

fileDisplayArea.innerText += "Autodetected Lithuanian charset of input file:\n" + e1.options[input_file_charset_selected_index + 1].text + "\n";


//fileDisplayArea.innerText += "inputFileName = " + inputFileName + "\n";
	
	
}//if(input_file_charset_selected_index == -1) // Autodetect Lithuanian charset
else
{
 number_of_nulls = 0;	
 max_number_of_lithuanian_chars = arrayBuffer.byteLength;	
}	
//===================================



//-----------------------------------------
// UTF-8 BOM (byte order mark) |  UTF-8 BOM
if(((input_file_charset_selected_index == 6) & (output_file_charset_selected_index == 6)) | ((input_file_charset_selected_index == 7) & (output_file_charset_selected_index == 7)))
{	

output_array = new Uint8Array(arrayBuffer.byteLength); 
i2 = 0;
for (i = 0; i < arrayBuffer.byteLength; i++) 
{ 
  current_byte = dataView.getUint8(i);
   if(current_byte == 0)
   { //remove null characters from file
   }
   else
   {
    output_array[i2] = current_byte;
	i2++;		   
   }	     
}//for (i = 0; i < arrayBuffer.byteLength; i++) 

}// if(((input_file_charset_selected_index == 6) & (output_file_charset_selected_index == 6)) | ((input_file_charset_selected_index == 7) & (output_file_charset_selected_index == 7)))
//-----------------------------------------
// input_file_charset_selected_index = UTF-8 BOM (byte order mark) & output_file_charset_selected_index = UTF-8
else if((input_file_charset_selected_index == 6) & (output_file_charset_selected_index == 7)) 
{	

output_array = new Uint8Array(arrayBuffer.byteLength - 3); 
i2 = 0;
for (i = 3; i < arrayBuffer.byteLength; i++) 
{ 
  current_byte = dataView.getUint8(i);
   if(current_byte == 0)
   { //remove null characters from file
   }
   else
   {
    output_array[i2] = current_byte;
	i2++;		   
   }	     
}//for (i = 0; i < arrayBuffer.byteLength; i++) 
	
} // else if((input_file_charset_selected_index == 6) & (output_file_charset_selected_index == 7)) 
//-----------------------------------------
// input_file_charset_selected_index = UTF-8 & output_file_charset_selected_index = UTF-8 BOM (byte order mark)
else if((input_file_charset_selected_index == 7) & (output_file_charset_selected_index == 6)) 
{	

output_array = new Uint8Array(arrayBuffer.byteLength + 3); 

 output_array[0] = 0xef;
 output_array[1] = 0xbb;
 output_array[2] = 0xbf;
 i2 = 3;

for (i = 0; i < arrayBuffer.byteLength; i++) 
{ 
  current_byte = dataView.getUint8(i);
   if(current_byte == 0)
   { //remove null characters from file
   }
   else
   {
    output_array[i2] = current_byte;
	i2++;		   
   }	     
}//for (i = 0; i < arrayBuffer.byteLength; i++) 
	
} // else if((input_file_charset_selected_index == 7) & (output_file_charset_selected_index == 6)) 
//-----------------------------------------
// input_file_charset_selected_index = UTF-8 & output_file_charset_selected_index = BOM (byte order mark)
else if((input_file_charset_selected_index == 7) & (output_file_charset_selected_index == 6)) 
{	

output_array = new Uint8Array(arrayBuffer.byteLength); 
i2 = 0;
for (i = 0; i < arrayBuffer.byteLength; i++) 
{ 
  current_byte = dataView.getUint8(i);
   if(current_byte == 0)
   { //remove null characters from file
   }
   else
   {
    output_array[i2] = current_byte;
	i2++;		   
   }	     
}//for (i = 0; i < arrayBuffer.byteLength; i++) 



}// else if((input_file_charset_selected_index == 7) & (output_file_charset_selected_index == 6)) 
//-----------------------------------------

//else if((input_file_charset_selected_index is not UTF-8) & (output_file_charset_selected_index is not UTF-8))
else if((input_file_charset_selected_index < 6) & (output_file_charset_selected_index < 6))
{

output_array = new Uint8Array(arrayBuffer.byteLength);	

i2 = 0;
for (i = 0; i < arrayBuffer.byteLength; i++) 
{ 

  current_byte = dataView.getUint8(i);
		
  char_was_replaced = 0;
		
//-----------     
   if(current_byte == 0)
   { //remove null characters from file
   }
   else if(current_byte > 127)
   {
	 for(icharset = 0; icharset < 18; icharset++)
	 {		
		table_value = LithuanianCharSetTable[icharset+(18*input_file_charset_selected_index)];
		if (table_value == current_byte)
		{
		 output_array[i2] = LithuanianCharSetTable[icharset+(18*output_file_charset_selected_index)];
		 i2++;	
		 char_was_replaced = 1;
		 number_of_replaced_characters++;
		 break;
		}//if (table_value = current_byte)
      }

   }//else if(current_byte > 127)
//-----------		

	if(char_was_replaced == 0)
	{
		output_array[i2] = current_byte;
		i2++;		
	}
	
}//for (i = 0; i < arrayBuffer.byteLength; i++) 		
		
	
	
}//else if((input_file_charset_selected_index < 6) & (output_file_charset_selected_index < 6))
//-----------------------------------------

//else if((input_file_charset_selected_index is not UTF-8) & (output_file_charset_selected_index is UTF-8))
else if((input_file_charset_selected_index < 6) & (output_file_charset_selected_index > 5))
{

//output_array = new Uint8Array(arrayBuffer.byteLength*2 + 3);


number_of_replaced_characters = 0;
i2 = 0;

if(output_file_charset_selected_index == 6) // UTF-8 BOM (byte order mark)
{
 output_array = new Uint8Array(arrayBuffer.byteLength + max_number_of_lithuanian_chars - number_of_nulls + 3);
	
 output_array[0] = 0xef;
 output_array[1] = 0xbb;
 output_array[2] = 0xbf;
 i2 = 3;
}//if(output_file_charset_selected_index == 6) // UTF-8 BOM (byte order mark)
else
{
 output_array = new Uint8Array(arrayBuffer.byteLength + max_number_of_lithuanian_chars - number_of_nulls);
 i2 = 0;
}	


for (i = 0; i < arrayBuffer.byteLength; i++) 
{ 
  current_byte = dataView.getUint8(i);
		
  char_was_replaced = 0;
		
//-----------     
   if(current_byte == 0)
   { //remove null characters from file
   }
   else if(current_byte > 127)
   {
	 for(icharset = 0; icharset < 18; icharset++)
	 {		
		table_value = LithuanianCharSetTable[icharset+(18*input_file_charset_selected_index)];
		if (table_value == current_byte)
		{
		 output_array[i2] = LithuanianCharSetTable[icharset+108];
		 i2++;	
		 output_array[i2] = LithuanianCharSetTable[icharset+126];
		 i2++;			 
		 
		 char_was_replaced = 1;
		 number_of_replaced_characters++;
		 break;
		}//if (table_value = current_byte)
      }

   }//else if(current_byte > 127)
//-----------		

	if(char_was_replaced == 0)
	{
		output_array[i2] = current_byte;
		i2++;		
	}
	
}//for (i = 0; i < arrayBuffer.byteLength; i++) 	



}// else if((input_file_charset_selected_index < 6) & (output_file_charset_selected_index > 5))
//-----------------------------------------
	

//else if((input_file_charset_selected_index is UTF-8) & (output_file_charset_selected_index is not UTF-8))
else if((input_file_charset_selected_index > 5) & (output_file_charset_selected_index < 6))
{

number_of_replaced_characters = 0;
i2 = 0;
var start_i = 0;

if(input_file_charset_selected_index == 6) // UTF-8 BOM (byte order mark)
{
 max_number_of_lithuanian_chars = CharSetStatisticsTable[6];
 output_array = new Uint8Array(arrayBuffer.byteLength - max_number_of_lithuanian_chars - number_of_nulls - 3);	
 start_i = 3;
}//if(input_file_charset_selected_index == 6) // UTF-8 BOM (byte order mark)
else
{
 max_number_of_lithuanian_chars = CharSetStatisticsTable[7];	
 output_array = new Uint8Array(arrayBuffer.byteLength - max_number_of_lithuanian_chars - number_of_nulls);
 start_i = 0;
}	


char_was_replaced = 0;

for (i = start_i; i < arrayBuffer.byteLength-1; i++) 
{ 

 if(char_was_replaced == 1)	 
 {
	char_was_replaced = 0; 
 } 
 else
 {	 
  current_byte = dataView.getUint8(i);
  current_byte2 = dataView.getUint8(i+1);
  

//-----------     
   if(current_byte == 0)
   {
     //number_of_nulls++;
   }
   else if(current_byte > 127)
   {   
	 for(icharset = 0; icharset < 18; icharset++)
	 {		
		table_value = LithuanianCharSetTable[icharset+108]; // UTF-8 first byte
		table_value2 = LithuanianCharSetTable[icharset+126]; // UTF-8 second byte
		if ((table_value == current_byte) & (table_value2 == current_byte2))
		{
         output_array[i2] = LithuanianCharSetTable[icharset+(18*output_file_charset_selected_index)];
		 i2++;		 
		 char_was_replaced = 1;
		 number_of_replaced_characters++;
		 break;
		}//if (table_value = current_byte)
      }//for(icharset = 0; icharset < 18; icharset++)
   }//else if(current_byte > 127)
//-----------	

	if(char_was_replaced == 0)
	{
		output_array[i2] = current_byte;
		i2++;		
	}

 }//else if(char_was_replaced == 0)	

	 
}//for (i = 0; i < arrayBuffer.byteLength; i++) 	

	
// The last char in the file
current_byte = dataView.getUint8(arrayBuffer.byteLength-1);
if((current_byte != 0) & (char_was_replaced == 0))
{
 output_array[i2] = current_byte;
 i2++;	
}



}// else if((input_file_charset_selected_index > 5) & (output_file_charset_selected_index < 6))
//-----------------------------------------	




	
	
output_array = output_array.slice(0, i2);	
var blob = new Blob([output_array], {type: "application/octet-stream"});		
		
		
//----------------------------		
var a = window.document.createElement('a');
a.href = window.URL.createObjectURL(blob);
	

inputFileFullName = file.name;
inputFileExtension = inputFileFullName.split('.').pop();


if (inputFileFullName) 
{
 inputFileName = inputFileFullName.substring(0, inputFileFullName.length - inputFileExtension.length - 1);
 
}
else
{
 inputFileName = "output";	
 inputFileExtension = "txt";
}					
				

//alert(inputFileName);
//alert(inputFileExtension);

if(output_file_format_selected_index == 0)
{
outputFileName = inputFileName + "_out." + inputFileExtension;
}
else //if(output_file_format_selected_index == 1)
{
outputFileName = inputFileName + "_out.txt";	
}


a.download = outputFileName;
document.body.appendChild(a);
a.click();
document.body.removeChild(a);			
		


fileDisplayArea.innerText += "Input filename = " + inputFileFullName + "\n";
fileDisplayArea.innerText += "Output filename = " + outputFileName + "\n";
fileDisplayArea.innerText += "Total number of characters = " + i2 + "\nNumber of replaced characters = " + number_of_replaced_characters + "\n\n";

		
//... process rest of dataView ...
//----------------------------		
		
		
};//return function(e0)
})(file); //reader.onload = (function(file)	


reader.readAsArrayBuffer(file);
				
				
}//if (file.type.match(textType))  
else 
{
	fileDisplayArea.innerText += "File not supported!\n";
}


}//for (i_file = 0; i_file < fileInput.files.length; i_file++)

		}); //fileInput.addEventListener('change', function(e) 

}//window.onload = function() 
